;------------------------------------------------------------------------
;-  Written by: sanmaiwashi (admin@wazoku.net)
;-     If you use my code, please share your creations with me
;-     as I am always curious :)
;------------------------------------------------------------------------

.DEFINE W_LINE		$40
.DEFINE L_S2_ADDR	$54
.DEFINE L_D_ADDR	$57
.DEFINE L_S_ADDR	$5A
.DEFINE W_PRINT_BIN_C	$60
.DEFINE L_D555		$D0
.DEFINE L_8000		$D3
.DEFINE L_AAAA		$D6
.DEFINE B_TARGET_BANK	$DF
.DEFINE L_SUM_ADDR	$E0
.DEFINE W_SUM		$E3
.DEFINE W_SUM_T		$E5
.DEFINE W_FLASH_ID	$E7
.DEFINE B_TEMP1		$ED
.DEFINE W_TEMP1		$EE

;---------------------------------------------------------------------------------
; LoRom
;---------------------------------------------------------------------------------

.MEMORYMAP             ; Tell WLA that the SNES has ROM at locations 8000-$FFFF
SLOTSIZE $8000         ; in every bank and that this area is $8000 bytes in size.
DEFAULTSLOT 0          ; There is only a single slot in SNES, other consoles
SLOT 0 $8000           ;	may have more slots per bank.
.ENDME

.ROMBANKSIZE $8000     ; Every ROM bank is 32 KBytes in size, also necessary.
.ROMBANKS 16           ; 4.0Mbits -- Tells WLA that you want to use 32 ROM banks.
.EMPTYFILL $FF
;---------------------------------------------------------------------------------

.BANK 0 SLOT 0
.ORG 0
Main:
	sei
	clc
	xce

	JML $008007
	
	rep #$20
	lda #$0000
	tcd             ; set Direct Page REG $0000

	lda #$1FFF      ; set stack to $1FFF
	tcs
	
	sep #$20

	lda #$00
	pha
	plb			; set DBR $00
	
	lda #$01
	sta $420d ;Set CPU speed to 3.58MHz

	lda #$01
	sta $4200 ;NMI disable

	lda #$8F
	sta $2100 ;turn screen off for now, set brightness to normal

	jsr ClearRegs
	
	stz $2106;Mosaic off

	lda #$00 ;BG1SC
	sta $2107

	lda #$01 ;BG12NBA 1000h
	sta $210B

	stz $210D ;BG0 H-Offset
	stz $210D ;
	stz $210E ;BG0 V-Offset
	stz $210E ;
	
	lda #$03
	sta $2121 ;set CG-RAM address
	lda #$FF  ; color white
	sta $2122
	sta $2122

	;load ankfont
	lda #$80
	sta $2115 ;Set VRAM word access
	rep #$10
	ldy #$1000
	sty $2116
	ldy #$0000
_font_loop:	
	lda.w ankfont, y

	sta $2118
	sta $2119
	
	iny
	cpy #ankfont_end - ankfont
	bne _font_loop
	
	lda #$00
	sta $2115 ;Set VRAM byte access mode

	ldy #$0020;upper & left text blank
	sty W_LINE
	sty $2116

	ldy #title_str
	lda #title_str_end - title_str
	jsr print_text

	lda #$40
	jsr text_enter

	;; copy code to $7E:8000
	ldy #$8000
	sty $4305 ; Set transfer byte count
	sty $4302 ; Set source addr
	sty $4300 ; Set transfer mode 0, dest $2180
	sty $2181 ; set $7E:8000
	stz $2183
	stz $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0

	jml $7E0000 + jmp_addr
	
jmp_addr:
	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	jsr onscreen

	ldy #$D555 ; $80:D555
	sty L_D555
	lda #$80
	sta L_D555 + 2

	ldy #$8000 ; $80:8000
	sty L_8000
	lda #$80
	sta L_8000 + 2

	ldy #$AAAA ; $80:AAAA
	sty L_AAAA
	lda #$80
	sta L_AAAA + 2

	lda #$80   ; $80:XXXX
	sta B_TARGET_BANK

	lda #$03+$0C ; CARD mode
	sta $2189
	
	;; GetID
	LDA #$AA	;
	STA [L_D555]	; $X0:D555
	LDA #$55	; 
	STA [L_AAAA]	; $X0:AAAA
	LDA #$90	; 
	STA [L_D555]	; $X0:D555

	rep #$20
	lda [L_8000]	; $X0:8000 
	sta W_FLASH_ID

	sep #$20

	;; Read/Reset
	lda #$F0	;
	sta [L_8000]	; $X0:8000

	;; GetROM
	rep #$20
	lda [L_8000]
	sta W_TEMP1

	sep #$20

	ldy W_FLASH_ID
	cpy #$A401
	bne _S0
	cpy W_TEMP1
	beq _S0

	jsr wait_vblank
	ldy #recovery_mode_str
	lda #recovery_mode_str_end - recovery_mode_str
	jsr print_text

	lda #$40
	jsr text_enter

	bra _next1
_S0:	
	stz L_D555 + 2		; $00:D555
	stz L_8000 + 2		; $00:8000
	stz L_AAAA + 2		; $00:AAAA
	stz B_TARGET_BANK	; $00:XXXX
_S1:
	;; GetID
	LDA #$AA	;
	STA [L_D555]	; $X0:D555
	LDA #$55	; 
	STA [L_AAAA]	; $X0:AAAA
	LDA #$90	; 
	STA [L_D555]	; $X0:D555

	rep #$20
	lda [L_8000]	; $X0:8000 
	sta W_FLASH_ID

	sep #$20

	;; Read/Reset
	lda #$F0	;
	sta [L_8000]	; $X0:8000

	;; check ID
	ldy W_FLASH_ID
	cpy #$A401
	beq _next0
	jsr wait_vblank
	ldy #none_str
	lda #none_str_end - none_str
	jsr print_text
	jmp stop
_next0:
	jsr wait_vblank
_next1:	jsr print_id
	lda #$40
	jsr text_enter
/*
	lda #$C0
	sta L_D_ADDR
	lda #$3F
	sta L_D_ADDR + 1
	lda #$00
	sta L_D_ADDR + 2
	
	ldy #$0040
	sty W_PRINT_BIN_C
	ldy #$0000
	jsr dump_addr

	lda #$20
	jsr text_enter
*/
	;; sum check

	lda #$02+$0C ; DRAM mode
	sta $2189

	lda #$00
	sta L_SUM_ADDR
	lda #$80
	sta L_SUM_ADDR + 1
	lda #$90
	sta L_SUM_ADDR + 2

	;; print firmware sum
	ldy #firm_sum_str
	lda #firm_sum_str_end - firm_sum_str
	jsr print_text
	jsr sum_calc
	jsr print_sum

	lda #$40
	jsr text_enter

	lda #$03+$0C ; CARD mode
	sta $2189

	lda #$00
	sta L_SUM_ADDR
	lda #$80
	sta L_SUM_ADDR + 1
	lda B_TARGET_BANK
	sta L_SUM_ADDR + 2

	;; print target sum
	ldy #target_sum_str
	lda #target_sum_str_end - target_sum_str
	jsr print_text
	jsr sum_calc
	ldy W_SUM ; save target sum
	sty W_SUM_T
	jsr print_sum

	lda #$40
	jsr text_enter

	;; wait joypad
	ldy #press_A_str
	lda #press_A_str_end - press_A_str
	jsr print_text

	lda #$40
	jsr text_enter

	;; wait A button press
_J0:	lda $4212
	and #$C1   ; It needs H/V blank check on real hardware.
	cmp #$C0
	bne _J0
	lda $4218
	bit #$80
	beq _J0

	;; backup target
	jsr wait_vblank
	ldy #backup_str
	lda #backup_str_end - backup_str
	jsr print_text

	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda B_TARGET_BANK
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$00
	sta L_S2_ADDR
	lda #$80
	sta L_S2_ADDR + 1
	lda #$7F
	sta L_S2_ADDR + 2 ; S2 address

_bcl:	lda #$03+$0C ; CARD mode
	sta $2189

	;; copy TARGET to $7F:8000
	ldy #$8000
	sty $4305 ; Set transfer byte count
	sty $4302 ; Set source addr
	sty $4300 ; Set transfer mode 0, dest $2180
	sty $2181 ; set $7F:8000
	lda #$01
	sta $2183
	lda L_S_ADDR + 2
	sta $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0

	lda #$00+$0C ; DRAM RW mode
	sta $2189

	ldy #$0000

_bcll:	lda [L_S2_ADDR], y
	sta [L_D_ADDR], y
	iny
	cpy #$8000
	bne _bcll

	jsr wait_char

	inc L_S_ADDR + 2
	inc L_D_ADDR + 2
	lda L_D_ADDR + 2
	cmp #$90
	bne _bcl
	
	;; OK!
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text

	lda #$40
	jsr text_enter

	lda #$02+$0C ; DRAM mode
	sta $2189

	lda #$00
	sta L_SUM_ADDR
	lda #$80
	sta L_SUM_ADDR + 1
	lda #$80
	sta L_SUM_ADDR + 2

	;; print backup sum
	ldy #backup_sum_str
	lda #backup_sum_str_end - backup_sum_str
	jsr print_text
	jsr sum_calc
	jsr print_sum

	lda #$40
	jsr text_enter

	;; if(backup == target)
	ldy W_SUM
	cpy W_SUM_T
	beq _next2

	ldy #sum_err_str
	lda #sum_err_str_end - sum_err_str
	jsr print_text

	jmp stop
_next2:	
	ldx #$0000
_cphl:	lda $80FFC0, x
	sta $3FA0, x
	inx
	cpx #$0020
	bne _cphl
	lda #$04 ; set DRAM data size
	sta $3FC1

	;; "UFOBIOS" filename
	lda #'U'
	sta $3FD2
	lda #'F'
	sta $3FD3
	lda #'O'
	sta $3FD4
	lda #'B'
	sta $3FD5
	lda #'I'
	sta $3FD6
	lda #'O'
	sta $3FD7
	lda #'S'
	sta $3FD8
	lda #' '
	sta $3FD9
	
	;; wait joypad
	ldy #press_B_str
	lda #press_B_str_end - press_B_str
	jsr print_text

	lda #$40
	jsr text_enter

	;; wait B button press
_J1:	lda $4212
	and #$C1   ; It needs H/V blank check on real hardware.
	cmp #$C0
	bne _J1
	lda $4219
	bit #$80
	beq _J1
	
	;; Chip Erase
	jsr wait_vblank
	ldy #erasing_str
	lda #erasing_str_end - erasing_str
	jsr print_text

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Chip Erase
	LDA #$AA	;
	STA [L_D555]	; $X0:D555
	LDA #$55	; 
	STA [L_AAAA]	; $X0:AAAA
	LDA #$80	; 
	STA [L_D555]	; $X0:D555
	LDA #$AA	;
	STA [L_D555]	; $X0:D555
	LDA #$55	; 
	STA [L_AAAA]	; $X0:AAAA
	LDA #$10	; 
	STA [L_D555]	; $X0:D555

	;; check status in progress
_cesl:	lda [L_8000]	; $X0:8000
	and #$40
	sta B_TEMP1
	lda [L_8000]	; $X0:8000
	and #$40
	cmp B_TEMP1
	bne _cesl

	;; Read/Reset
	lda #$F0	;
	sta [L_8000]	; $X0:8000

	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text

	lda #$40
	jsr text_enter

	
	;; Byte Program
	ldy #writing_str
	lda #writing_str_end - writing_str
	jsr print_text

	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$90
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda B_TARGET_BANK
	sta L_D_ADDR + 2 ; D address

	lda #$00
	sta L_S2_ADDR
	lda #$80
	sta L_S2_ADDR + 1
	lda #$7F
	sta L_S2_ADDR + 2 ; S2 address

_bpl:	lda #$02+$0C ; DRAM mode
	sta $2189

	;; copy firmware to $7F:8000
	ldy #$8000
	sty $4305 ; Set transfer byte count
	sty $4302 ; Set source addr
	sty $4300 ; Set transfer mode 0, dest $2180
	sty $2181 ; set $7F:8000
	lda #$01
	sta $2183
	lda L_S_ADDR + 2
	sta $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0

	lda #$03+$0C ; CARD mode
	sta $2189

	ldy #$0000

_bpll:	;; Byte Program
	LDA #$AA	;
	STA [L_D555]	; $X0:D555
	LDA #$55	; 
	STA [L_AAAA]	; $X0:AAAA
	LDA #$A0	; 
	STA [L_D555]	; $X0:D555

	lda [L_S2_ADDR], y
	sta [L_D_ADDR], y

	;; check status in progress
_bpsl:	lda [L_8000]	; $X0:8000
	and #$40
	sta B_TEMP1
	lda [L_8000]	; $X0:8000
	and #$40
	cmp B_TEMP1
	bne _bpsl

	iny
	cpy #$8000
	bne _bpll

	jsr wait_char

	inc L_S_ADDR + 2
	inc L_D_ADDR + 2
	lda L_S_ADDR + 2
	cmp #$A0
	bne _bpl

	;; Read/Reset
	lda #$F0	;
	sta [L_8000]	; $X0:8000
	
	;; OK!
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text

	lda #$40
	jsr text_enter

	lda #$03+$0C ; CARD mode
	sta $2189

	lda #$00
	sta L_SUM_ADDR
	lda #$80
	sta L_SUM_ADDR + 1
	lda B_TARGET_BANK
	sta L_SUM_ADDR + 2

	;; print target sum
	ldy #target_sum_str
	lda #target_sum_str_end - target_sum_str
	jsr print_text
	jsr sum_calc
	jsr print_sum

	lda #$40
	jsr text_enter
	
	;; finished
	ldy #finished_str
	lda #finished_str_end - finished_str
	jsr print_text
	
stop:	bra stop

dump_addr:
_dal:	jsr wait_vblank
	jsr _print_bin
	lda #$20
	jsr text_enter
	cpy W_PRINT_BIN_C
	beq _dal_e
	bra _dal
_dal_e:	rts

_print_bin:
	lda L_D_ADDR + 2
	jsr _charconv_h
	sta $2118
	lda L_D_ADDR + 2
	jsr _charconv_l
	sta $2118
	lda #':'
	sta $2118

	rep #$20
	tya
	clc
	adc L_D_ADDR
	sta W_TEMP1
	sep #$20
	
	lda W_TEMP1 + 1
	jsr _charconv_h
	sta $2118
	lda W_TEMP1 + 1
	jsr _charconv_l
	sta $2118

	lda W_TEMP1
	jsr _charconv_h
	sta $2118
	lda W_TEMP1
	jsr _charconv_l
	sta $2118

	lda #' '
	sta $2118

_pbl:	lda [L_D_ADDR], y
	jsr _charconv_h
	sta $2118
	lda [L_D_ADDR], y
	jsr _charconv_l
	sta $2118
	lda #' '
	sta $2118

	iny
	tya
	bit #$07
	bne _pbl
	rts

sum_check:
	ldy #$0000
_scl:	sep #$20
	lda [L_SUM_ADDR], y
	rep #$20
	and #$00FF
	clc
	adc W_SUM
	sta W_SUM
	iny
	cpy #$8000
	bne _scl
	rts
	
sum_calc:
	rep #$20
	lda #$0000
	sta W_SUM
_sum_loop:	
	jsr sum_check
	sep #$20
	lda L_SUM_ADDR + 2
	bit #$01
	beq _swc
	pha
	jsr wait_char
	pla
_swc:	inc A
	bit #$0F
	beq _sum_end
	sta L_SUM_ADDR + 2
	bra _sum_loop
_sum_end:
	rts
	
print_sum:
	lda W_SUM + 1
	jsr _charconv_h
	sta $2118
	lda W_SUM + 1
	jsr _charconv_l
	sta $2118
	lda W_SUM
	jsr _charconv_h
	sta $2118
	lda W_SUM
	jsr _charconv_l
	sta $2118
	rts

print_id:
	;; print ID
	lda #'I'
	sta $2118
	lda #'D'
	sta $2118
	lda #':'
	sta $2118
	lda W_FLASH_ID + 1
	jsr _charconv_h
	sta $2118
	lda W_FLASH_ID + 1
	jsr _charconv_l
	sta $2118
	lda W_FLASH_ID
	jsr _charconv_h
	sta $2118
	lda W_FLASH_ID
	jsr _charconv_l
	sta $2118
	rts

_charconv:
	and #$0F
	cmp #$0A
	bcs _cv0
	clc
	adc #$30
	bra _cv1
_cv0:	clc
	adc #$37
_cv1:	rts
	
_charconv_h:
	lsr
	lsr
	lsr
	lsr
	jsr _charconv
	rts
	
_charconv_l:
	and #$0F
	jsr _charconv
	rts
	
onscreen:
	lda #$00 ;set BGMode 0
	sta $2105 ;BG 0,1,2,3 tile size 8x8, off Highest priority for BG3
	sta $2133
	lda #$01
	sta $212C
	lda #$0F
	sta $2100
	rts

wait_vblank:
	lda $4210
	bpl wait_vblank
	rts
	
wait_char:
_WL:	lda $4210
	bpl _WL
	lda #'.'
	sta $2118
	rts
	
print_text:
	;Copy Text data to VRAM
	sta $4305  ; Set transfer byte count
	stz $4306
	sty $4302  ; Set source addr
	rep #$10
	ldy #$1800 ; Set transfer mode 0, dest $2118
	sty $4300
	phk
	pla
	sta $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0
	rts

text_enter:
	rep #$20
	and #$00FF
	clc
	adc W_LINE
	and #$FFE0
	sta W_LINE
	sta $2116
	sep #$20
	rts
	
ClearRegs:
	;set WRAM address
	;clr WRAM 2000h - 1FFFFh
	stz $2181 ;WRAM address low
	lda #$20
	sta $2182 ;WRAM address middle
	stz $2183 ;WRAM address high

	;set VRAM address
	lda #$80
	sta $2115 ;Set VRAM port to word access
	stz $2116 ;VRAM read/write address (low)
	stz $2117 ;VRAM read/write address (high)

	;set OAM address
	stz $2102 ;Sprite write address (low)
	stz $2103 ;Sprite register write address (high), sprite priority rotation bit.

	;set CG-RAM address
	stz $2121

	phk
	pla
	sta $4304 ;Set source bank WRAM
	sta $4314 ;Set source bank VRAM
	sta $4324 ;Set source bank OAM
	sta $4334 ;Set source bank CG-RAM
	
	rep #$10
	ldy #$8008 ;Set transfer mode 0, dest $2180, fixed address source for WRAM clr.
	sty $4300
	ldy #$1809 ;Set transfer mode 1(dest word mode), dest $2118, fixed address source for VRAM clr.
	sty $4310
	ldy #$0408 ;Set transfer mode 0, dest $2104, fixed address source for OAM clr.
	sty $4320
	ldy #$2208 ;Set transfer mode 0, dest $2122, fixed address source for CG-RAM clr.
	sty $4330
	
	ldy #zero
	sty $4302 ;Set source addr WRAM
	sty $4312 ;Set source addr VRAM
	sty $4322 ;Set source addr OAM
	sty $4332 ;Set source addr CG-RAM
	
	ldy #$e000 ;Set transfer byte count WRAM
	sty $4305
	ldy #$0000 ;Set transfer byte count VRAM
	sty $4315
	ldy #$0220 ;Set transfer byte count OAM
	sty $4325
	ldy #$0200 ;Set transfer byte count CG-RAM
	sty $4335
	
	lda #$0F
	sta $420B ;Do DMA transfer channel 0 1 2 3

	ldy #$0000 ;Set transfer byte count WRAM
	sty $4305

	lda #$01
	sta $420B ;Do DMA transfer channel 0

	;clr WRAM address
	stz $2181 ;WRAM address low
	stz $2182 ;WRAM address middle
	stz $2183 ;WRAM address high

	;clr VRAM address
	stz $2116 ;VRAM read/write address (low)
	stz $2117 ;VRAM read/write address (high)

	;clr OAM address
	stz $2102 ;Sprite write address (low)
	stz $2103 ;Sprite register write address (high), sprite priority rotation bit.

	;clr CG-RAM address
	stz $2121

	stz $2123 ;Window 1 and 2 enable for backgrounds 1 and 2
	stz $2124 ;Window 1 and 2 enable for backgrounds 3 and 4
	stz $2125 ;Window 1 and 2 enable for objects and colour window
	stz $2126 ;Window 1 left position
	stz $2127 ;Window 1 right position
	stz $2128 ;Window 2 left position
	stz $2129 ;Window 2 right position
	stz $212A ;Windows 1 & 2 overlap logic for backgrounds 1 - 4
	stz $212B ;Windows 1 & 2 overlap logic for objects and colour window
	stz $212C ;Main screen designation (backgrounds 1 - 4 and objects)
	stz $212D ;Sub-screen designation (backgrounds 1 - 4 and objects)
	stz $212E ;Window mask designation for main screen ?
	stz $212F ;Window mask designation for sub-screen ?
	stz $2130 ;Fixed colour addition or screen addition
	stz $2131 ;Colour addition or subtraction select
	stz $2132 ;Colour data for fixed colour addition/subtraction

	rts

NMIHandler:
	rti

IRQHandler:
	rti
	
EmptyHandler:
	rti

title_str:
.DB "UFO FLASH"
title_str_end:

firm_sum_str:
.DB "FIRMWARE CHKSUM"
firm_sum_str_end:

target_sum_str:
.DB "TARGET CHECKSUM"
target_sum_str_end:

backup_sum_str:
.DB "BACKUP CHECKSUM"
backup_sum_str_end:

none_str:
.DB "UFO flash memory is none"
none_str_end:

press_A_str:
.DB "Press A button to proceed"
press_A_str_end:

press_B_str:
.DB "Press B button to proceed"
press_B_str_end:

backup_str:
.DB "Backup TARGET"
backup_str_end:

erasing_str:
.DB "Erasing Chip..."
erasing_str_end:

writing_str:
.DB "Writing"
writing_str_end:

recovery_mode_str:
.DB "Recovery mode"
recovery_mode_str_end:

finished_str:
.DB "Finished, Enter to Reset."
finished_str_end:
	
ok_str:
.DB "OK!"
ok_str_end:
	
sum_err_str:
.DB "CHECKSUM ERROR! Stop"
sum_err_str_end:
	
ankfont:
.INCBIN "ankfont.dat"
ankfont_end:

zero:
.DB $00, $00

; === Cartridge Header - part 1 - =====================
.ORG    $7FB0
.DB     $00, $00                ; New Licensee Code ( 01 == Nintendo )
.DB     $00, $00, $00, $00      ; ID
.DB     $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
.ORG    $7FC0
.DB     "UFO FLASH PROGRAM    " ; Title (can't be more than 21 bytes, and should probably be a full 21 bytes)
;       "0123456789ABCDEF01234" ; cart name length
.ORG    $7FD5
.DB     $30                     ; Memory Mode   ( $20 = Slow LoRom, $21 = Slow HiRom $30 = Fast LoRom, $31 = Fast HiRom )

; === Cartridge Header - part 2 - =====================
.ORG    $7FD6
.DB     $00                   ; Contents ( $00 = ROM only, $01 = ROM and RAM, $02 = ROM and Save RAM)
.DB     $0A                   ; ROM Size   ( $08 = 2 Mbit, $09 = 4 Mbit, $0A = 8Mbit, $0B = 16Mbit ... etc )
.DB     $00                   ; SRAM Size ( $00 = 0 bits, $01 = 16 kbits, $02 = 32 kbits, $03 = 64 kbits )
.DB     $00                   ; Country ( $01 = USA, $00 = Jap )
.DB     $00                   ; Licensee Code
.DB     $00                   ; Version
.DW    $FFFF                  ; Checksum Complement  (not calculated ... but who cares?)
.DW    $0000                  ; Checksum

; === Interrupt Vector Table ====================
.ORG    $7FE4                 ; === Native Mode ===
.DW     EmptyHandler          ; COP
.DW     EmptyHandler          ; BRK
.DW     EmptyHandler          ; ABORT
.DW     NMIHandler            ; NMI
.DW     $0000                 ; (Unused)
.DW     IRQHandler            ; IRQ

.ORG    $7FF4                 ; === Emulation Mode ===
.DW     EmptyHandler          ; COP
.DW     $0000                 ; (Unused)
.DW     EmptyHandler          ; ABORT
.DW     NMIHandler            ; NMI
.DW     Main                  ; RESET
.DW     IRQHandler            ; IRQ/BRK

; ============================================
